#include "project.h"
#include "IPStackMain.h"

/*MAC address to be assigned to the ENC28J60*/
const unsigned char devMAC[6] = {0x00,0x59,0xc9,0x14,0xc8,0x00};

/*IP address to be assigned to the ENC28J60*/
const unsigned char devIP[4] = {192,168,0,15};

int main( void ){

CyGlobalIntEnable;
    /*Initialize the IP Stack*/
   // IPstack_Start(myMAC,myIP);  //IPStack.c_483   initializes the IP Stack,and the Chip and performs an ARP request
 
        short i = 0;
    ARP arpPacket;

    /*Copy the passed MAC and IP into our Global variables*/
    memcpy(deviceMAC,devMAC,6);
    memcpy(deviceIP,devIP,4);
     
    /*Initialize SPI and the Chip's memory,PHY etc.*/
    initMAC( deviceMAC );
 //--------------------------------------------------------------------------------------------------------------------OK   
       //printf(" IPStack_482_initMAC \n");   !!!!!!!!!!!!!!!!!!        no !!! ?????

      
    
    /*Lets find the router's MAC address*/
   // SendArpRequest( routerIP );     // ARP.c___28

    
   //------------------------------------------------------------------- 
    
    
   /*      SendArpRequest( routerIP )------*/
   // unsigned int ii = 0;

    /*Lets declare a packet of structure type ARP*/
    //ARP arpPacket;
    
    /*----Setup EtherNetII Header----*/
    /*The source of the packet will be the ENC28J60 mac address.*/
    memcpy( arpPacket.eth.SrcAddrs, deviceMAC,6 );

    /*The destination is broadcast,so thats a MAC Address of 
    0xFF:0xFF:0xFF:0xFF:0xFF:0xFF:0xFF */
    memset( arpPacket.eth.DestAddrs,0xFF, 6 );
    
    /*The type of packet being sent is an ARP*/
    arpPacket.eth.type = (ARPPACKET);
  
    /*----Setup ARP Header----*/
    arpPacket.hardware = (ETHERNET);

    /*We want an IP address resolved.*/
    arpPacket.protocol = (IPPACKET);
    arpPacket.hardwareSize = 0x06;
    arpPacket.protocolSize = 0x04;
    arpPacket.opCode = (ARPREQUEST);
  
    /*Target MAC is set to 0 as it is unknown.*/
    memset( arpPacket.targetMAC, 0, 6 );
    
    /*Sender MAC is the ENC28J60's MAC address.*/
    memcpy( arpPacket.senderMAC, deviceMAC, 6 );
    
    /*The target IP is the IP address we want resolved.*/
    memcpy( arpPacket.targetIP, routerIP, 4);
    
    /*Sender IP will be the device IP*/
    memcpy( arpPacket.senderIP, deviceIP, 4);



    /*Send the Packet*/
    return(MACWrite((unsigned char*)&arpPacket,sizeof(ARP)));
   //------------------------------------------------------------------------------ 
  
    
    
    
    
    
    
    
    /*Lets wait for the reply*/
    for(i=0; i < 0x5fff; i++){
        if( MACRead( (unsigned char*) &arpPacket, sizeof(ARP) )!=0 ){
        //    if( (arpPacket.eth.type == (ARPPACKET))&& (arpPacket.opCode == (ARPREPLY)) && (!memcmp( arpPacket.senderIP, routerIP, sizeof(routerIP) )) ){
        //        /*Aha! The router sends back its MAC.Copy it into our appropriate global var.*/
                 memcpy( routerMAC, arpPacket.senderMAC, sizeof(routerMAC) );
         //      return TRUE;
         //   }
        }
    // printf("IPstack_Start_MACRead %d i=\n",i); 
    }
     // printf("MACRead ERROR\n");   
    return FALSE;
    
    
    
    
    
  
    for(;;){
    
    	//IPstackIdle();
        
     //CyDelay(1);   
        
    }    
    
}